#!/bin/bash
# file ALU8/test.sh
# created mar. déc. 31 00:11:19 CET 2019 by Yann Guidon / ygdes.com
# version mer. janv.  1 17:05:28 CET 2020
#
# Released under the GNU AGPLv3 license

if [ ! -f ../proasic3v3/proasic3-obj93.cf  ]; then
  echo -n '--> going to ' ; pushd ../proasic3v3/
  ./build.sh
  echo -n '<-- back to ' ; popd
fi

if [ ! -f ../Y8/proasic3-obj93.cf  ]; then
  echo -n '--> going to ' ; pushd ../Y8/
  ./build.sh
  echo -n '<-- back to ' ; popd
fi

PA3="-P../proasic3v3 -P../Y8"

echo &&
echo "checking the functionality:" &&
echo &&

rm -f *.cf *.o test_rop2 &&
ghdl -a $PA3 ROP2_ASIC.vhdl test_ROP2.vhdl && ghdl -e $PA3 test_ROP2 && ./test_rop2 |sed 's/.*(report note)://' &&

echo &&
echo "checking the ROP2's netlist:" &&
echo &&
rm -f *.cf *.o test_rop2 vectgen &&
ghdl -a $PA3 ROP2_ASIC.vhdl Wrap_ROP2.vhdl ../proasic3v3/VectGen.vhdl && ghdl -e $PA3 VectGen && ./vectgen |sed 's/.*(report note)://' &&
rm -f *.cf *.o vectgen &&

echo &&
echo "ROP2 : OK !" &&
echo &&

echo &&
echo "Now checking the CLA's netlist:" &&
echo &&
rm -f *.cf *.o &&
ghdl -a $PA3 gate_CLA3b.vhdl gate_CLA3bn.vhdl CLA8_ASIC.vhdl Wrap_CLA8.vhdl ../proasic3v3/VectGen.vhdl &&
    ghdl -e $PA3 VectGen && ./vectgen |sed 's/.*(report note)://' &&
rm -f *.cf *.o vectgen &&

echo &&
echo "CLA8 : OK !" &&
echo &&

ghdl -a $PA3 gate_CLA3b.vhdl gate_CLA3bn.vhdl CLA8_ASIC.vhdl ROP2_ASIC.vhdl ALU8.vhdl Wrap_ALU8.vhdl ../proasic3v3/VectGen.vhdl &&
 ghdl -e $PA3 VectGen && ./vectgen |sed 's/.*(report note)://' &&

rm -f *.cf *.o vectgen &&

ghdl -a $PA3 ../ASM/Y8asm.vhdl gate_CLA3b.vhdl gate_CLA3bn.vhdl CLA8_ASIC.vhdl ROP2_ASIC.vhdl ALU8.vhdl dec_ALU8.vhdl test_decoder.vhdl &&
ghdl -e $PA3 test_decoder &&
./test_decoder &&

echo &&
echo "ALU8 : OK !" &&
echo
