#!/bin/bash
# A3Pv2.8/proasic3v3/build_simple.sh
# version lun. mars 23 03:43:56 CET 2020
# version jeu. jul. 16 01:38:59 2020 : added aliases.vhdl
#
# This version creates a file with no extra feature,
# for easy synthesis on other platforms.

VER="--std=93"

# some cleanup :
rm -f *.cf *.o gategen PA3_components.vhdl PA3_definitions.vhdl &&

# compile the SLV utilities
ghdl -a $VER --work=SLV SLV_utils.vhdl &&

# compile the histogram definitions
ghdl -a $VER --work=Histo Histograms.vhdl &&
# not used by the PA3_components.vhdl but included by gategen

# compile the "gate generator":
ghdl -a $VER --work=proasic3 PA3_genlib.vhdl gategen.vhdl  &&
ghdl -e $VER --work=proasic3 gategen &&
# run and generate the whole gates:
./gategen -ggate_type="simple" && # -ggate_delay="1 ns" &&

# now compile the library :
ghdl -a $VER --work=proasic3 PA3_definitions.vhdl PA3_components.vhdl PA3_combi.vhdl aliases.vhdl &&

echo "Library generation : OK"
